/**
 * @file usb_host_task.c,v
 *
 * 쌠 (c) 2004 Atmel.
 *
//! 쌠ʒmɂĂlicense.txţقǂ݂B
 *
 * @brief ̧قUSBνĐAνė(ڑF)菇A~ĊJνėvǗ܂B
 *
 * ̍Ƃ͌v敔Ƃ𔺂܂񂪁AWusb_task璼ړIɌĂ΂܂B
 *
 * @version 1.21 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_host_task.c,v 1.21 2007/02/13 12:10:34 arobert Exp $
 *
 * @todo
 * @bug
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "modules/usb/usb_task.h"
#include "usb_host_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "lib_mcu/pll/pll_drv.h"
#include "modules/usb/host_chap9/usb_host_enum.h"

#if (USB_OTG_FEATURE == ENABLED)
  #include "modules/usb/device_chap9/usb_device_task.h"
  #if (TARGET_BOARD==SPIDER)
	#include "lib_board/lcd/lcd_drv.h"
  #endif

  #ifndef OTG_ENABLE_HNP_AFTER_SRP
	#warning  OTG_ENABLE_HNP_AFTER_SRP should be defined somewhere in config files (conf_usb.h)
  #endif

  #ifndef OTG_B_DEVICE_AUTORUN_HNP_IF_REQUIRED
	#warning  OTG_B_DEVICE_AUTORUN_HNP_IF_REQUIRED should be defined somewhere in config files (conf_usb.h)
  #endif

  #ifndef OTG_VBUS_AUTO_WHEN_A_PLUG
	#warning  OTG_VBUS_AUTO_WHEN_A_PLUG should be defined somewhere in config files (conf_usb.h)
  #endif

  #ifndef OTG_ADEV_SRP_REACTION
	#warning  OTG_ADEV_SRP_REACTION should be defined somewhere in config files (conf_usb.h)
  #endif

  #if (HOST_STRICT_VID_PID_TABLE != ENABLE)
	#warning  HOST_STRICT_VID_PID_TABLE must be defined to ENABLED to comply with Targeted Peripheral List requirements
  #endif
#endif


#if (USB_HOST_FEATURE == DISABLED)
  #warning trying to compile a file used with the USB HOST without USB_HOST_FEATURE enabled
#endif

#if (USB_HOST_FEATURE == ENABLED)

#ifndef DEVICE_ADDRESS
  #error DEVICE_ADDRESS should be defined somewhere in config files (conf_usb.h)
#endif

#ifndef SIZEOF_DATA_STAGE
  #error SIZEOF_DATA_STAGE should be defined in conf_usb.h
#endif

#ifndef HOST_CONTINUOUS_SOF_INTERRUPT
  #error HOST_CONTINUOUS_SOF_INTERRUPT should be defined as ENABLE or DISABLE in conf_usb.h
#endif

#ifndef USB_HOST_PIPE_INTERRUPT_TRANSFER
  #error USB_HOST_PIPE_INTERRUPT_TRANSFER should be defined as ENABLE or DISABLE in conf_usb.h
#endif

#ifndef Usb_id_transition_action
  #define Usb_id_transition_action()
#endif
#ifndef  Host_device_disconnection_action
  #define Host_device_disconnection_action()
#endif
#ifndef  Host_device_connection_action
  #define Host_device_connection_action()
#endif
#ifndef  Host_sof_action
  #define Host_sof_action()
#endif
#ifndef  Host_suspend_action
  #define Host_suspend_action()
#endif
#ifndef  Host_hwup_action
  #define Host_hwup_action()
#endif
#ifndef  Host_device_not_supported_action
  #define Host_device_not_supported_action()
#endif
#ifndef  Host_device_class_not_supported_action
  #define Host_device_class_not_supported_action()
#endif
#ifndef  Host_device_supported_action
  #define Host_device_supported_action()
#endif
#ifndef  Host_device_error_action
  #define Host_device_error_action()
#endif

//_____ ϸ ________________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_device_connected[]="Device Connection";
U8 code log_device_enumerated[]="Device Enumerated";
U8 code log_device_unsupported[]="Unsupported Device";
U8 code log_going_to_suspend[]="Usb suspend";
U8 code log_usb_resumed[]="Usb resumed";
#endif

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

#if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
  volatile S_pipe_int	it_pipe_str[MAX_EP_NB];
  volatile U8 pipe_nb_save;
  U8 g_sav_int_sof_enable;
#endif

#if (USB_OTG_FEATURE == ENABLED)
  //! J: (U8) otg_device_connected;
  //! zVBUS ONSRP󂯎̍ŏx(B-uڑ҂)
  U16 otg_ta_srp_wait_connect;

  //! J: (U8) otg_device_connected;
  //! xA-νĂx~(Suspend)`Ԃɐݒ肳鎞ɐؒfB-uɑ΂őx
  U16 otg_ta_aidl_bdis_tmr;

  //! J: (U8) otg_device_connected;
  //! Va_vbus_valid臒lɒB邽߂VBUSpőx
  U8 otg_ta_vbus_rise;

  //! J: (U8) otg_device_connected;
  //! UB-utꂽɍŏA-uvɉ邽߂̍őx
  U16 otg_timeout_bdev_respond;

  //! J: (U8) otg_device_connected;
  //! ڑӋ@\OTGuۂB
  U8 otg_device_connected;

  //! J: (U8) otg_a_device_srp;
  //! A-uSRPɂĂ̓ʂȎۂi[
  U8  otg_a_device_srp;

  //! J: (U8) otg_end_hnp_vbus_delay;
  //! vbus_valid臒lӂł̒邽߂VBUSdݸނɎgpϐ
  U16 otg_end_hnp_vbus_delay;
#endif

//!
//! J: U8 device_state
//! ̒lUSBνĐɐڑꂽǔ݂̏Ԃ\܂B
//! l͈ȉŗL蓾܂B
//! - DEVICE_ATTACHED
//! - DEVICE_POWERED
//! - DEVICE_SUSPENDED
//! - DEVICE_DEFAULT
//! - DEVICE_ADDRESSED
//! - DEVICE_CONFIGURED
//! - DEVICE_ERROR
//! - DEVICE_UNATTACHED
//! - DEVICE_READY
//! - DEVICE_WAIT_RESUME
//! - DEVICE_DISCONNECTED
//! - DEVICE_DISCONNECTED_ACK
//!
//! OTGɑ΂Ĉȉ4ǉĂ܂B:
//! - A_PERIPHERAL
//! - A_INIT_HNP
//! - A_SUSPEND
//! - A_END_HNP_WAIT_VFALL
//!/
U8 device_state;

//! ߲0̐vǗp
S_usb_setup_data usb_request;

//!
//! J: U8 data_stage[SIZEOF_DATA_STAGE];
//! USBްiKepRAMɏՕ
//! ̊ɏՕνė(ڑF)̍\ݒɕKvƂ܂B
//! ͎MuLqq܂݂܂B
//! uLqqɈˑāȂ傫conf_usb.ḩقSIZEOF_DATA_STAGE`ōœK邱Ƃł܂B
//!
//!/
U8 data_stage[SIZEOF_DATA_STAGE];

U8 device_status;
U8 request_resume;

static U16 c;								// ڰщ񐔌vƂ

U8 new_device_connected=0;

/**
 * @brief ̊֐νē`ԂłUSBƒgϐ܂B
 *
 * ̊֐USBνē`Ԃŋ܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 */
void usb_host_task_init (void)
{
	Pll_start_auto();
	Wait_pll_ready();
	Usb_disable();
	Usb_enable();
	Usb_unfreeze_clock();
	Usb_attach();
	Usb_enable_uvcon_pin();
	Usb_select_host();
	Usb_disable_vbus_hw_control();			// Ԓ߂ȂVBUS
	Host_enable_device_disconnection_interrupt();
	#if (USB_OTG_FEATURE == ENABLED)
	Usb_enable_id_interrupt();
		#if (OTG_ADEV_SRP_REACTION == VBUS_PULSE)
		Usb_select_vbus_srp_method();
		#else
		Usb_select_data_srp_method();
		#endif
	#endif
	device_state=DEVICE_UNATTACHED;
}

/**
 * @brief USBνĊǗ̓_
 *
 * _͑u(device_state)ɈˑĖڕWuڑƗ(ڑF)Ǘ
 * ƂŁA֐͗񋓂Č`Ԑݒ肳ꂽu𓾂邽߂ɕKvȑs܂B
 * UuɂȂƁAdevice_statelDEVICE_READYłB
 * uɑ΂Ăǂȉpvŝɐ旧āȀԂνčƉpɂ
 * ČׂłB
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 *
 * \image html host_task.gif
 */
void usb_host_task (void)
{
	U32 dec;
	U8  desc_temp;
	switch (device_state)
	{
		//------------------------------------------------------
		// DEVICE_UNATTACHED
		//
		// - 菉
		// - ud͋^悤ƂB
		//
		case DEVICE_UNATTACHED:
			for (c=0;c<MAX_EP_NB;c++) {ep_table[c]=0;}	// u߲ ڽ߲ߎQƕ\ؾ
			nb_interface_supported=0;
			Host_clear_device_supported();	// uؾ
			Host_clear_configured();
			Host_clear_device_ready();
			Usb_clear_all_event();			// SĂ̿ĳۂ
			new_device_connected=0;
#if (USB_OTG_FEATURE == ENABLED)
			Host_end_session_started_srp();
			Peripheral_is_not_otg_device();
			Usb_host_reject_hnp();
			Usb_disable_role_exchange_interrupt();
			Usb_disable_hnp_error_interrupt();
#endif
			if (Is_usb_id_host())
			{
#if (SOFTWARE_VBUS_CTRL==ENABLE)
				if( Is_usb_bconnection_error_interrupt()||Is_usb_vbus_error_interrupt())
				{
					Usb_ack_bconnection_error_interrupt();
					Usb_ack_vbus_error_interrupt();
					Host_clear_vbus_request();
				}
	#if ((USB_OTG_FEATURE == DISABLED) || (OTG_VBUS_AUTO_WHEN_A_PLUG == ENABLED))
				if (Is_usb_id_host())
				{
					Host_ack_device_connection();
					Usb_enable_manual_vbus();
					Host_vbus_action();
		#if (USB_OTG_FEATURE == ENABLED)
					Init_ta_vbus_rise_counter();
		#endif
				}
	#endif
	#if ((USB_OTG_FEATURE == ENABLED) && (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED))
				// VBUSON܂OFFɐ؂芷邽߂̎gpҗv
				if (Is_usb_id_host() && Is_user_requested_vbus())
				{
					Ack_user_request_vbus();
					if (Is_usb_vbus_manual_on())
					{
						Usb_disable_vbus();
						Usb_disable_manual_vbus();
						Host_vbus_action();
					}
					else
					{
						Usb_enable_manual_vbus();
						Host_vbus_action();
						Init_ta_vbus_rise_counter();
					}
				}

		#if (OTG_VBUS_AUTO_AFTER_A_PLUG_INSERTION == ENABLED)
				if (id_changed_to_host_event == ENABLED)
				{
					id_changed_to_host_event = DISABLED;
					Usb_enable_manual_vbus();
					Init_ta_vbus_rise_counter();
					Host_vbus_action();
				}
		#endif
	#endif

	#if (USB_OTG_FEATURE == ENABLED)
				if (Is_ta_vbus_rise_counter_overflow() && Is_usb_vbus_low() && Is_usb_vbus_manual_on())
				{
					// VBUSONɐ؂芷邽߂̎蓮gpҗv̏ꍇATa_vbus_rise(㏸mF)O
					// VBUSVa_vbus_validɒBȂꍇɈُүނ𐶐܂B
					Usb_disable_vbus();
					Usb_disable_manual_vbus();
					Host_vbus_action();
					Otg_print_new_event_message(OTGMSG_VBUS_SURCHARGE,OTG_TEMPO_3SEC);
					Otg_print_new_failure_message(OTGMSG_UNSUPPORTED,OTG_TEMPO_4SEC);
				}
	#else
				Usb_disable_vbus_pad();
				Usb_enable_manual_vbus();
	#endif

				if(Is_usb_srp_interrupt())
				{
					Usb_ack_srp_interrupt();

					if (!Is_usb_vbus_manual_on())	// VBUSɔzĂȂꍇA͎ۂSRPł(OTG B-u)B
					{
	#if (USB_OTG_FEATURE == ENABLED)
						Otg_print_new_event_message(OTGMSG_SRP_RECEIVED,OTG_TEMPO_2SEC);
						Host_session_started_srp();
						Init_ta_srp_counter();
						Srp_received_and_waiting_connect();
						Init_ta_vbus_rise_counter();
	#endif
					}
					device_state=DEVICE_ATTACHED;
					Usb_ack_bconnection_error_interrupt();
					Usb_enable_vbus_pad();
					Usb_enable_vbus();
					Host_vbus_action();
				}
#else
				Usb_enable_vbus();				// Œᑕud͋^!!!
				Host_vbus_action();
				if(Is_usb_vbus_high())
				{ device_state=DEVICE_ATTACHED; }	// VBUSOKȂAuڑ\z֍s
#endif
			}
	#if (USB_OTG_FEATURE == ENABLED)
			else
			if (otg_b_device_state == B_HOST)
			{
				device_state = DEVICE_ATTACHED;
			}
	#endif
			break;

		//------------------------------------------------------
		// DEVICE_ATTACHED
		//
		// - VBUSON
		// - oꂽuڑs
		//
		case DEVICE_ATTACHED:
#if (USB_OTG_FEATURE == ENABLED)
			if (Is_device_connection() || (Is_usb_id_device() && (otg_b_device_state == B_HOST)))
#else
			if (Is_device_connection())	// uٱߌo
#endif
			{
				Host_ack_device_connection();
	#if (USB_OTG_FEATURE == ENABLED)
				Ack_srp_received_and_connect();	// ڑSRPɂėv邩܂B
	#endif
				// ⑕uڑAؒf荞݋
				Host_enable_device_disconnection_interrupt();
				Enable_interrupt();
				// uؾ
				Host_clear_device_supported();
				Host_clear_configured();
				Host_clear_device_ready();
				Host_ack_sof();
				Host_enable_sof();			// ڰъJn(SOF)Jn
				Host_enable_sof_interrupt();	// SOF͊荞݉Ōoł傤B
				c = 0;
				while (c<100)				// USBؾđO100msҋ@
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }	// ڰъJnv
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt()) {goto device_attached_error;}
	#if (USB_OTG_FEATURE == ENABLED)
					if (Is_usb_device_enabled()) { break; }
	#endif
				}
				Host_disable_device_disconnection_interrupt();

				Host_send_reset();			// ŏUSBؾ
				Usb_ack_event(EVT_HOST_SOF);
				while (Is_host_reset())
				{
	#if (USB_OTG_FEATURE == ENABLED)
					if (Is_usb_device_enabled()) { break; }
	#endif
				} // ؾĂ̍Ō̊҂
				Host_ack_reset();

	#if (USB_OTG_FEATURE == ENABLED)
				// gp҂͘A鑽ؾđoIԂƂł܂B
				c = 1;
				while (c != OTG_RESET_LENGTH)
				{
					Host_send_reset();
					Usb_ack_event(EVT_HOST_SOF);
					while (Is_host_reset())
					{
		#if (USB_OTG_FEATURE == ENABLED)
						if (Is_usb_device_enabled()) { break; }
		#endif
					} // ؾĂ̍Ō̊҂
					Host_ack_reset();
					c++;
				}
	#endif

				// d͂̏Ȃٱ߂޸ނ̂邢̑uɑ΂΍
				// ʏްɂ₩ɏ㏸ᑬ(Low-Speed)͐ؒfƂĉ߂꓾܂B
				for(c=0;c!=0xFFFF;c++)		// {Ԓߌv
				{
					if(Is_usb_event(EVT_HOST_SOF))	// SOFȍꍇAu͑u͖ڑĐĂāAPɌĂؒf׸ނ܂B
					{
						if(Is_device_disconnection())
						{
							Host_ack_device_connection();
							Host_ack_device_disconnection();
							break;
						}
					}
				}
				Host_enable_device_disconnection_interrupt();
				c = 0;
				while (c<100)				// USBؾČ100msҋ@
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }	// ڰъJnv
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt()) {goto device_attached_error;}
	#if (USB_OTG_FEATURE == ENABLED)
					if (Is_usb_device_enabled()) { break; }
	#endif
				}
				device_state = DEVICE_POWERED;
				c=0;
			}
	#if ((USB_OTG_FEATURE == ENABLED) && (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED))
			else
			{
				// SRPڑ
				if (Is_srp_received_and_waiting_connect())
				{
					// SRPƑuڑԂŎԒ߂
					if (Is_ta_srp_counter_overflow())
					{
						Ack_srp_received_and_connect();
						Clear_all_user_request();
						device_state = DEVICE_DISCONNECTED;
						Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
					}

					if (Is_usb_bconnection_error_interrupt())
					{	// B-uSRP𑗂Aʰ޳ɂĎ󂯓ꂽőڑxɐڑ鎞Ɏgp܂B
						// VBUS܂(ݻɂ̂߂ɏo͂͗܂)B
						Usb_ack_bconnection_error_interrupt();
						Usb_disable_vbus();
						Usb_disable_vbus_pad();
						Usb_enable_vbus_pad();
						Usb_enable_vbus_hw_control();
						Usb_enable_vbus();
					}
				}
				if (Is_ta_vbus_rise_counter_overflow() && Is_usb_vbus_low())
				{
					// VBUSONɐ؂芷邽߂̎蓮gpҗv̏ꍇATa_vbus_rise(㏸mF)O
					// VBUSVa_vbus_validɒBȂꍇɈُүނ𐶐܂B
					Usb_disable_vbus();
					Usb_disable_manual_vbus();
					Host_vbus_action();

					device_state = DEVICE_DISCONNECTED;

					Otg_print_new_event_message(OTGMSG_VBUS_SURCHARGE,OTG_TEMPO_3SEC);
					Otg_print_new_failure_message(OTGMSG_UNSUPPORTED,OTG_TEMPO_4SEC);
				}
			}
	#endif

	#if ((USB_OTG_FEATURE == ENABLED) && (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED))
			// VBUSOFFɐ؂芷gpҗv
			if (Is_usb_id_host() && Is_user_requested_vbus())
			{
				Ack_user_request_vbus();
				Usb_disable_vbus();
				Usb_disable_manual_vbus();
				Host_vbus_action();
				device_state = DEVICE_UNATTACHED;
			}
	#endif

			device_attached_error:
	#if ((USB_OTG_FEATURE == DISABLED) || (OTG_VBUS_AUTO_WHEN_A_PLUG == ENABLED))
			// uڑُ܂VBUS pb  n߂ڑ菇Ďs
			if( Is_usb_bconnection_error_interrupt()||Is_usb_vbus_error_interrupt()||Is_usb_vbus_low())
			{
				if (Is_usb_id_host())
				{
					Usb_ack_bconnection_error_interrupt();
					Usb_enable_vbus_hw_control();
					device_state=DEVICE_UNATTACHED;
					Usb_disable_vbus();
					Usb_disable_vbus_pad();
					Usb_enable_vbus_pad();
					Usb_ack_vbus_error_interrupt();
					Usb_enable_vbus();
					Usb_disable_vbus_hw_control();
					Host_disable_sof();
					Host_vbus_action();
				}
				else { device_state = DEVICE_UNATTACHED; }
			}
	#endif

			break;

		//------------------------------------------------------
		// DEVICE_POWERED
		//
		// - uڑ(t)o
		// - 100msҋ@Ɗ萧߲ߌ`Ԑݒ
		//
		case DEVICE_POWERED:
			LOG_STR_CODE(log_device_connected);
			Host_device_connection_action();
			if (Is_usb_event(EVT_HOST_SOF))
			{
				Usb_ack_event(EVT_HOST_SOF);
				if (c++ >= 100)				// 100msҋ@
				{
					device_state = DEVICE_DEFAULT;
					Host_select_pipe(PIPE_CONTROL);
					Host_enable_pipe();
					host_configure_pipe(PIPE_CONTROL, \
										TYPE_CONTROL, \
										TOKEN_SETUP,  \
										EP_CONTROL,   \
										SIZE_8,       \
										ONE_BANK,     \
										0             );
					device_state = DEVICE_DEFAULT;
				}
			}
			break;

		//------------------------------------------------------
		// DEVICE_DEFAULT
		//
		// - uLqq擾
		// - u߲0ɏ]߲0Č`Ԑݒ
		// - uڽ𑮂B
		//
		case DEVICE_DEFAULT:
			// ŏ̑uLqq擾
	#if (USB_OTG_FEATURE == ENABLED)
			Peripheral_is_not_otg_device();	// ԕϐ
			Init_timeout_bdev_response();	// (usb_task.cŌv튄荞݂ɂď)B-u"waiting response"x
	#endif
			if( CONTROL_GOOD == host_get_device_descriptor_uncomplete())
			{
				c = 0;
				while(c<20)					// USBؾČ20msҋ@(ʂ޸ޑû)
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt())  {break;}
				}
				Host_disable_device_disconnection_interrupt();

				Host_send_reset();			// ŏUSBؾ
				Usb_ack_event(EVT_HOST_SOF);
				while (Is_host_reset());	// ؾĂ̍Ō̊҂
				Host_ack_reset();
	#if (USB_OTG_FEATURE == ENABLED) // OTGK̂߁AؾĎԂ>50msłȂ΂Ȃ܂(ؾĊԒx<3ms)B
				c = 1;
				while (c != OTG_RESET_LENGTH)
				{
					Host_send_reset();
					Usb_ack_event(EVT_HOST_SOF);
					while (Is_host_reset());	// ؾĂ̍Ō̊҂
					Host_ack_reset();
					c++;
					}
	#endif

				// d͂̏Ȃٱ߂޸ނ̂邢̑uɑ΂΍
				// ʏްɂ₩ɏ㏸ᑬ(Low-Speed)͐ؒfƂĉ߂꓾܂B
				for(c=0;c!=0xFFFF;c++)		// {Ԓߌv
				{
					if(Is_usb_event(EVT_HOST_SOF))	// SOFȍꍇAu͑u͖ڑĐĂāAPɌĂؒf׸ނ܂B
					{
						if(Is_device_disconnection())
						{
							Host_ack_device_connection();
							Host_ack_device_disconnection();
							break;
						}
					}
				}
				Host_enable_device_disconnection_interrupt();
				c = 0;
				while(c<200)				// USBؾČ200msҋ@
				{
					if (Is_usb_event(EVT_HOST_SOF)) { Usb_ack_event(EVT_HOST_SOF); c++; }
					if (Is_host_emergency_exit() || Is_usb_bconnection_error_interrupt())  {break;}
				}
				Host_select_pipe(PIPE_CONTROL);
				Host_disable_pipe();
				Host_unallocate_memory();
				Host_enable_pipe();
				// u߲Tɏ]Đ߲߂Č`Ԑݒ
				host_configure_pipe(PIPE_CONTROL, \
									TYPE_CONTROL, \
									TOKEN_SETUP,  \
									EP_CONTROL,   \
									host_determine_pipe_size((U16)data_stage[OFFSET_FIELD_MAXPACKETSIZE]), \
									ONE_BANK,     \
									0            );
				// Αuڽ^B
				host_set_address(DEVICE_ADDRESS);
				Host_configure_address(DEVICE_ADDRESS);
				device_state = DEVICE_ADDRESSED;
			}
			else
			{
				device_state = DEVICE_ERROR;
			}
			break;

		//------------------------------------------------------
		// DEVICE_ADDRESSED
		//
		// - VIDPIDxꗗ
		//
		case DEVICE_ADDRESSED:
			if (CONTROL_GOOD == host_get_device_descriptor())
			{
				// ڑꂽuxu\ɑm
				if (HOST_TRUE == host_check_VID_PID())
				{
					Host_set_device_supported();
					Host_device_supported_action();
					device_state = DEVICE_CONFIGURED;
	#if (USB_OTG_FEATURE == ENABLED)
					// OTG A-νďԂŁAB-uSRPł̍ƂvꂽꍇHNPJn
					if ((OTG_ENABLE_HNP_AFTER_SRP == ENABLED) && Is_host_session_started_srp() && Is_usb_id_host())
					{
						device_state = A_INIT_HNP;
					}
					else
					{
						if (Is_device_supports_hnp())
						{
							if (CONTROL_GOOD != host_set_feature_a_hnp_support())
							{
								device_state = A_END_HNP_WAIT_VFALL;	// uvs\(STALL)ꍇɍƏI
							}
						}
					}
	#endif
				}
				else
				{
	#if (USB_OTG_FEATURE == ENABLED)
					// OTGŁAB-uVID/PIDڕWӋ@\ꗗƈvȂꍇA"x"ƕB
					//  - uxȂAHNPJnȂ΂Ȃ܂B
					//  - ُүނ\(A"Wu"""ԂňႢ)Ȃ΂Ȃ܂B
					desc_temp = data_stage[OFFSET_DEV_DESC_CLASS];	// (ތɑ΂)u׽i[
					if (otg_b_device_state != B_HOST)
					{
						if (Is_host_session_started_srp())
						{
							if (CONTROL_GOOD == host_get_configuration_descriptor())
							{
								host_check_OTG_features();
								if (Is_device_supports_hnp())
								{
									device_state = A_INIT_HNP;	// x(܂͎)uHNPvN܂B
								}
								else
								{
									device_state = A_END_HNP_WAIT_VFALL;
									if (desc_temp == HUB_CLASS_CODE)
									{
										// "x"үޕ\
										Otg_print_new_failure_message(OTGMSG_UNSUPPORTED_HUB,OTG_TEMPO_4SEC);
									}
									else
									{
										// "x׽"үޕ\
										Otg_print_new_failure_message(OTGMSG_UNSUPPORTED,OTG_TEMPO_4SEC);
									}
								}
							}
							else
							{
								device_state = A_END_HNP_WAIT_VFALL;
							}
						}
						else
						{
							device_state = A_INIT_HNP;
						}
					}
					else
					{
						Otg_print_new_failure_message(OTGMSG_UNSUPPORTED,OTG_TEMPO_4SEC);
						Set_user_request_disc();	// ƏI₤B
						Set_user_request_suspend();
					}
	#else
		#if (HOST_STRICT_VID_PID_TABLE==ENABLE)
					device_state = DEVICE_ERROR;
					Host_device_not_supported_action();
		#else
					device_state = DEVICE_CONFIGURED;
		#endif
	#endif
				}

			}
			else // uLqq𓾂ȂB
			{ device_state = DEVICE_ERROR; }
			break;

		//------------------------------------------------------
		// DEVICE_CONFIGURED
		//
		// - x̪ɑ΂߲߂`Ԑݒ
		// - Set_configuration()vo
		// - S`Ԃ֍s(u)
		//
		case DEVICE_CONFIGURED:
			if (CONTROL_GOOD == host_get_configuration_descriptor())
			{
				if (HOST_FALSE != host_check_class())	// ׽xOK?
				{
	#if (USB_OTG_FEATURE == ENABLED)
					// ݂ȂAӋ@\OTGLqqɂĂ̏W
					host_check_OTG_features();
	#endif
	#if (HOST_AUTO_CFG_ENDPOINT==ENABLE)
					host_auto_configure_endpoint();
	#else
					User_configure_endpoint();	// gp҂͎`Ԑݒ̑ɂŌĂяo
					Host_set_configured();	// `Ԑݒ͎gpҌ`ԐݒOKƉ
	#endif
					if (Is_host_configured())
					{
						if (CONTROL_GOOD== host_set_configuration(1))	// Set_configurationo
						{
//							host_set_interface(interface_bound,interface_bound_alt_set);
							// uνĂ͍⊮SɌ`Ԑݒ肳܂B
							// DEVICE READYW֍sB
							device_state = DEVICE_READY;
							// 荞݉őuؒfĎ
							Host_enable_device_disconnection_interrupt();
							// gpνĉpSOF荞ݎۂKvȏꍇ
							// SOF荞݋ۂAȂ΂̊荞݂֎~
	#if (HOST_CONTINUOUS_SOF_INTERRUPT==DISABLE)
							Host_disable_sof_interrupt();
	#endif
							new_device_connected=TRUE;
							Enable_interrupt();
							LOG_STR_CODE(log_device_enumerated);
						}
						else // Set_configurationv̖
						{ device_state = DEVICE_ERROR; }
					}
				}
				else // u׽xȂB
				{
					device_state = DEVICE_ERROR;
					LOG_STR_CODE(log_device_unsupported);
					Host_device_class_not_supported_action();
				}
			}
			else // `ԐݒLqq擾łȂB
			{ device_state = DEVICE_ERROR; }
			break;

     //------------------------------------------------------
		// DEVICE_READY
		//
		// - SW`
		// - ׂƂ͉Ȃ
     //
		case DEVICE_READY:					// νĊSW`!
			new_device_connected=FALSE;

			// gpҗv:"VBUS~(stop Vbus)""x~(suspend)"
	#if (USB_OTG_FEATURE == ENABLED)
			if (Is_usb_id_host())
			{
		#if (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED)
				if (Is_user_requested_vbus())
				{
					Ack_user_request_vbus();
					Usb_disable_vbus();
					Usb_disable_manual_vbus();
					Host_vbus_action();
					Clear_all_user_request();
					device_state = A_END_HNP_WAIT_VFALL;
				}
		#endif

				if (Is_user_requested_suspend() || Is_user_requested_hnp())
				{
					// x~(Suspend)`Ԃ֓OɁAB-Ӌ@\ɂĎxĂ΁AA-νĂSetFeature(b_hnp_enable)𑗂Ȃ΂Ȃ܂B
					Ack_user_request_hnp();
					Ack_user_request_suspend();
					device_state = A_INIT_HNP;
				}
			}
	#endif
			break;

		//------------------------------------------------------
		// DEVICE_ERROR
		//
		// - ُ
		// - ƎĂ(蓮`Ԃ֍s)
		//
		case DEVICE_ERROR:
	#if (USB_OTG_FEATURE == ENABLED)  // TBD
			device_state=DEVICE_UNATTACHED;
	#elif (HOST_ERROR_RESTART==ENABLE)
			device_state=DEVICE_UNATTACHED;
	#endif
			Host_device_error_action();
			break;

		//------------------------------------------------------
		// DEVICE_SUSPENDED
		//
		// - νĉp͑ůx~邱Ƃv
		// - Host_request_suspend()ɂďԋ@\͂ɗ܂B
		//
		case DEVICE_SUSPENDED:
			// OTGuȂAHNP菇Jn(Ԃ֍s)
			if ((USB_OTG_FEATURE == ENABLED) && Is_peripheral_otg_device())
			{
				device_state = A_INIT_HNP;
			}
			else
			{
				device_state=DEVICE_WAIT_RESUME;	// uĊJ(Resume)ۑ҂
				if(Is_device_supports_remote_wakeup())	// ڑꂽuuNxꍇ
				{
					if (CONTROL_GOOD != host_set_feature_remote_wakeup())
					{
						device_state = DEVICE_DISCONNECTED;	// u@\󂯓Ȃ߂ɐڑ~
					}
				}

				LOG_STR_CODE(log_going_to_suspend);
				c = Is_host_sof_interrupt_enabled();	// ݂SOF荞݋Ԃۑ
				Host_disable_sof_interrupt();
				Host_ack_sof();
				Host_disable_sof();			// ڰъJn(SOF)~A͋x~(Suspend)Ԃ𐶐܂B

				Host_ack_remote_wakeup();
				Host_enable_remote_wakeup_interrupt();
				Host_ack_hwup();
				Host_enable_hwup_interrupt();	// νċNオ芄荞݋
											// (ܰ޳ݓ삩CPUNオ点邱ƂłƎUSB荞݂łB
				Usb_freeze_clock();
				Stop_pll();
				Host_suspend_action();		// Ǝ͂! (Ⴆܰޓ֍sȂ)
			}
			break;

		//------------------------------------------------------
		// DEVICE_WAIT_RESUME
		//
		// - νĂuĊJ(Resume)󂯎܂ŁA܂
		// - ν ĳuɍĊJv܂ł̏Ԃő҂
		//
		case DEVICE_WAIT_RESUME:
			if(Is_usb_event(EVT_HOST_REMOTE_WAKEUP)|| Is_host_request_resume())	// uNo܂͋ǏĊJvM
			{
				if(Is_host_request_resume())	// uNł͂ȂAνĉpv
				{
					Host_disable_hwup_interrupt();	// Nオ芄荞݂νĂNオċ֎~ׂł!B
					// x:HWUPUSBۯɎɂ邱Ƃł܂B
					Pll_start_auto();		// USB̂߂̍ŏPLLĎn
					Wait_pll_ready();		// PLLŒ艻mF擾
					Usb_unfreeze_clock();	// USB̪ł̸ۯ
				}
				Host_ack_hwup();			// HWUP荞׸މ
				Host_enable_sof();

				if (Is_usb_event(EVT_HOST_REMOTE_WAKEUP))
				{
					Usb_ack_event(EVT_HOST_REMOTE_WAKEUP);	// ĳۉ
					Host_disable_sof_interrupt();
					Host_ack_device_disconnection();
					Host_disable_device_disconnection_interrupt();

					Host_send_resume();		// ̑̉ĊJ(Resume)(uł͂Ȃ)νċ쓮ĊJ̍ŏ20msۏ؂邽߂ɍs܂B
					while (!Is_device_disconnection() && Host_is_resume());
					c = 0;
					Host_ack_sof();
					while (!Is_device_disconnection() && (c != 12))	// u񕜎Ԃ̍ŏ10ms҂
					{
						if (Is_host_sof())
						{
							Host_ack_sof();
							c++;
						}
					}
					if (Is_device_disconnection())
					{
						usb_host_task_init();
						device_state = DEVICE_DISCONNECTED;
						Host_ack_remote_wakeup();	// uNM
						Host_ack_request_resume();	// ĳv
						Host_ack_down_stream_resume();	// ĊJo
	#if ((USB_OTG_FEATURE == ENABLED) && (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED))
						Usb_disable_vbus();
						Usb_disable_manual_vbus();
						Host_vbus_action();
						Clear_all_user_request();
						while (Is_usb_vbus_high());
	#endif
					}
					else
					{
						device_state = DEVICE_READY;
						Host_ack_remote_wakeup();	// uNM
						Host_ack_request_resume();	// ĳv
						Host_ack_down_stream_resume();	// ĊJo
					}
					Host_enable_device_disconnection_interrupt();
					Host_ack_sof();
				}
				else
				{
					Host_send_resume();		// ĊJ(Resume)o
					//-----------------------
					// x~(Suspend)̑uؒf̏ꍇɑ΂΍
					// ؒf͌ČoꂸAĊJ(Rwsume)ޯĂ1ɗ܂(RSMEDI׸ނ͌Đݒ(1)܂)B
					// Ԓ߂̏ꍇAuڑ(ĊJޯĂ邽߂)USBϸۂؾĂ邱ƂӖ܂B
					dec = 0;
					while (dec < 0x4FFFF)	// 100ms
					{
						if (Is_host_down_stream_resume())	// ĊJo҂
						{
							Host_ack_remote_wakeup();	// uNM
							Host_ack_request_resume();	// ĳv
							Host_ack_down_stream_resume();	// ĊJo
							if(c) { Host_enable_sof_interrupt(); }	// x~(Suspend)OSOF荞݋Ԃ𕜌
							device_state=DEVICE_READY;	// S`ԕA
							LOG_STR_CODE(log_usb_resumed);
							dec = 0x3FFFFE;	// JԂIB
						}
						dec++;
					}

					if (dec != 0x3FFFFF)	// ĊJsꍇ
					{
						usb_host_task_init();
						device_state = DEVICE_DISCONNECTED;
	#if ((USB_OTG_FEATURE == ENABLED) && (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED))
						Usb_disable_vbus();
						Usb_disable_manual_vbus();
						Host_vbus_action();
						Clear_all_user_request();
						while (Is_usb_vbus_high());
	#endif
					}
					else
					{
						c = 0;
						Host_ack_sof();
						while (!Is_device_disconnection() && (c != 12))	// u񕜎Ԃ̍ŏ10ms҂
						{
							if (Is_host_sof())
							{
								Host_ack_sof();
								c++;
							}
						}
					} //----------------------- ΍̏I
				}
			}
	#if ((USB_OTG_FEATURE == ENABLED) && (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED))
			// "VBUS~"gpҗv
			if (Is_user_requested_vbus() && Is_usb_id_host())
			{
				Ack_user_request_vbus();
				Usb_disable_vbus();
				Usb_disable_manual_vbus();
				Host_vbus_action();
				Clear_all_user_request();
				device_state = A_END_HNP_WAIT_VFALL;
			}
	#endif
			break;

		//------------------------------------------------------
		// DEVICE_DISCONNECTED
		//
		// - uؒfo
		// - νĉpƂɂČoꂽmȎۂ𓾂邽߂ɍŒ2񂱂̏ԂŌv敔𑖍s
		// - v敔SpƂĂԂ̂mɓ邽߂DEVICE_UNATTACHED̑ODEVICE_DISCONNECTED_ACKԂ֍sB
		//
		case DEVICE_DISCONNECTED:
			device_state = DEVICE_DISCONNECTED_ACK;
			break;

		//------------------------------------------------------
		// DEVICE_DISCONNECTED_ACK
		//
		// - uؒfoĉpƂɂĊǗ܂B
		// - DEVICE_UNATTACHEDԂ֍sB
		//
		case DEVICE_DISCONNECTED_ACK:
			host_disable_all_pipe();
			device_state = DEVICE_UNATTACHED;
	#if (USB_OTG_FEATURE == ENABLED)
			if (OTG_VBUS_AUTO_WHEN_A_PLUG == DISABLED)
			{
				Usb_disable_manual_vbus();
				Usb_disable_vbus();
				Host_vbus_action();
				Clear_all_user_request();
			}
			End_session_with_srp();
			Usb_ack_srp_interrupt();
	#endif
			break;

#if (USB_OTG_FEATURE == ENABLED)
		//------------------------------------------------------
		// OTGL: A_PERIPHERAL (A-νĂHNPɑu֐؂芷܂B)
		//
		// - x~(Suspend)ԌoɍƏI(VBUS쓮~)
		// - gpҗvŐؒf
		// - ߲0v邽߂ɕW(OTG)uĂяo
		//
		case A_PERIPHERAL:
			// ̏I:A_Ӌ@\DEVICE_DISCONNECTED`ԂɂȂ:VBUS~
			if (Is_usb_event(EVT_USB_SUSPEND))
			{
				Clear_all_user_request();
				Usb_ack_event(EVT_USB_SUSPEND);
				Usb_disable_wake_up_interrupt();
				Usb_ack_role_exchange_interrupt();
				Usb_select_host();
				Usb_attach();
				Usb_unfreeze_clock();
				otg_b_device_state = B_IDLE;
				device_state = A_END_HNP_WAIT_VFALL;
				Usb_ack_srp_interrupt();
			}
			if (Is_user_requested_disc() || Is_user_requested_vbus())
			{
				Clear_all_user_request();
				Usb_disable_suspend_interrupt();
				Usb_ack_role_exchange_interrupt();
				Usb_select_host();
				Usb_unfreeze_clock();
				otg_b_device_state = B_IDLE;
				device_state = A_END_HNP_WAIT_VFALL;
			}
			if (!Is_device_disconnection_event() && (device_state != A_END_HNP_WAIT_VFALL))
			{
				usb_device_task();
			}
			break;

		//------------------------------------------------------
		// OTGL: A_INIT_HNP
		//
		// - HNPn߂邽߂ɗvꂽɿĳ̏Ԃɓ܂B
		// - B_HNP_ENABLE܂REMOTE_WAKE_UP̂悤"@\ݒ"߂
		// - s
		//
		case A_INIT_HNP:
			Ack_user_request_hnp();
			Ack_user_request_suspend();
			if (Is_peripheral_otg_device() || !Is_host_configured())
			{
				device_state = A_SUSPEND;
				if(Is_device_supports_remote_wakeup() && Is_host_configured())	// ڑꂽuuNオxꍇ
				{
					if (CONTROL_GOOD == host_set_feature_remote_wakeup())
					{
						Host_ack_remote_wakeup();
						Host_enable_remote_wakeup_interrupt();
						Host_ack_hwup();
						Host_enable_hwup_interrupt();	// νċNオ芄荞݋
					}
					else
					{
						device_state = A_END_HNP_WAIT_VFALL;	// u@\s\(Stall)ɂߐڑ~
					}
				}

				if (Is_device_supports_hnp() || !Is_host_configured())
				{
					if (CONTROL_GOOD == host_set_feature_b_hnp_enable())
					{
						// B-uSetFeatures\ɂȂB
						Usb_host_accept_hnp();
						Usb_ack_role_exchange_interrupt();
						Usb_ack_hnp_error_interrupt();
						Usb_enable_role_exchange_interrupt();
						Usb_enable_hnp_error_interrupt();
						Host_disable_device_disconnection_interrupt();
						Host_disable_device_connection_interrupt();
					}
					else
					{
						Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
						device_state = A_END_HNP_WAIT_VFALL;
					}
				}
				Host_ack_remote_wakeup();
				Host_enable_remote_wakeup_interrupt();
				Init_ta_aidl_bdis_counter();
				Host_disable_sof_interrupt();
				Host_ack_sof();
				Host_disable_sof();			// ڰъJn~A͋x~(Suspend)Ԃ𐶐
				Usb_disable_suspend_interrupt();
			}
			else
			{
				device_state = DEVICE_SUSPENDED;
			}
			break;

		//------------------------------------------------------
		// OTGL: A_SUSPEND
		//
		// - HNPJn̂߂B-uɗv鎞A-νĂ͂̏Ԃɓ܂B
		// - (HNPԒߊǗ)u̒قƍĊJ(Resume)Ԃo܂B
		//
		case A_SUSPEND:
			Usb_ack_suspend();
			// HNP͊荞݂ɂĊǗ܂(HNPERRI/ROLEEXI)B
			if (Is_ta_aidl_bdis_counter_overflow())
			{
				device_state = A_END_HNP_WAIT_VFALL;	// VBUS~=݂̍Ƃ̏I
			}
			if (Is_usb_event(EVT_HOST_HWUP)|| Is_host_request_resume())
			{
				device_state = DEVICE_WAIT_RESUME;
			}
			break;

		//------------------------------------------------------
		// OTGL: A_END_HNP_WAIT_VFALL
		//
		// - B-νĂx~(Suspend)o鎞A-Ӌ@\̏Ԃɓ܂B
		// - VBUSz~A(SRPo邽߂)̕d҂܂B
		//
		case A_END_HNP_WAIT_VFALL:
			Usb_disable_manual_vbus();
			Usb_disable_vbus();
			usb_configuration_nb = 0;
			Host_vbus_action();
			Clear_all_user_request();
	#if (OTG_COMPLIANCE_TRICKS == ENABLED)
			device_state = DEVICE_DISCONNECTED;
			usb_host_task_init();
	#else
			if (Is_usb_vbus_low())
			{
				usb_host_task_init();
				Init_ta_vbus_fall_counter();
				device_state = A_TEMPO_VBUS_DISCHARGE;
			}
	#endif
			break;

		//------------------------------------------------------
		// OTGL: A_TEMPO_VBUS_DISCHARGE
		//
		// - VBUSvbus_valid臒lɒxBɁAA_END_HNP_WAIT_VFALLڍs
		// - ̏ԂŁA(ڑȂA)VBUS̑uŗLłȂƂmɂ邽߁A[(50ms)҂܂B
		// - xo߂ƁAؾďԂɂȂ܂B
		case A_TEMPO_VBUS_DISCHARGE:
			if (otg_end_hnp_vbus_delay == 0)
			{
				Host_ack_device_connection();
				Host_ack_device_disconnection();
				Usb_ack_role_exchange_interrupt();
				Usb_ack_srp_interrupt();
				device_state = DEVICE_DISCONNECTED;
			}
			break;
#endif

		//------------------------------------------------------
		// 
		//
		// - : ERROR
		// - uԂȂ֍sB
		//
		default :
			device_state = DEVICE_UNATTACHED;
			break;
	}
}

/*_____ Ǘꂽް̗߰ݸނ邽ߊ֐ ___________________________*/

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data𑗂܂B
  *
  * @note ̊֐͎Ԓ߂o邽߂νSOF荞݂ɂ܂B荞݋SOF͕܂B
  * interrupt enable sof will be restore.
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	
  */
U8 host_send_data (U8 pipe, U16 nb_data, U8 *buf)
{
	U8 c;
	U8 status=PIPE_GOOD;
	U8 sav_int_sof_enable;
	U8 nak_timeout;
	U16 cpt_nak;
	U8 nb_data_loaded;

	sav_int_sof_enable=Is_host_sof_interrupt_enabled();	// SOF荞݋ԕۑ
	Host_enable_sof_interrupt();
	Host_select_pipe(pipe);
	Host_set_token_out();
	Host_ack_out_sent();
	while (nb_data != 0)					// 鉽
	{
		Host_unfreeze_pipe();
		// ׂް
		c = Host_get_pipe_length();
		if ( (U16)c > nb_data)
		{
			nb_data_loaded = (U8)nb_data;
			c = nb_data;
		}
		else
		{ nb_data_loaded = c; }
		while (c!=0)						// ߲ߊɏՕݒ
		{
			Host_write_byte(*buf++);
			c--;
		}
		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		cpt_nak=0;
		nak_timeout=0;
		Host_ack_out_sent();
		Host_send_out();
		while (!Is_host_out_sent())
		{
			if (Is_host_emergency_exit())	// 荞݉Ōoꂽ񓯊ؒf܂͖ύX
			{
				status=PIPE_DELAY_TIMEOUT;
				Host_reset_pipe(pipe);
				goto host_send_data_end;
			}
	#if (TIMEOUT_DELAY_ENABLE==ENABLE)
			if (private_sof_counter>=250)	// 250msv(250SOF)
			{
				private_sof_counter=0;
				if (nak_timeout++>=TIMEOUT_DELAY)	// oߎԐisƈꌟ
				{
					status=PIPE_DELAY_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_send_data_end;
				}
			}
	#endif
			if (Is_host_pipe_error())		// ُ?
			{
				status = Host_error_status();
				Host_ack_all_errors();
				goto host_send_data_end;
			}
			if (Is_host_stall())			// s\(STALL)Ǘ
			{
				status =PIPE_STALL;
				Host_ack_stall();
				goto host_send_data_end;
			}
	#if (NAK_TIMEOUT_ENABLE==ENABLE)
			if(Is_host_nak_received())		// NAKM
			{
				Host_ack_nak_received();
				if (cpt_nak++>NAK_SEND_TIMEOUT)
				{
					status = PIPE_NAK_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_send_data_end;
				}
			}
	#endif
		}
		// OUTo
		nb_data -= nb_data_loaded;
		status=PIPE_GOOD;					// ڰѐ푗o
		Host_ack_out_sent();
	}
	Host_freeze_pipe();
host_send_data_end:
	// SOF荞݋ԕ
	if (sav_int_sof_enable==FALSE) {Host_disable_sof_interrupt();}
	// ĕA
	return ((U8)status);
}

/**
  * @brief ̊֐͎w肳ꂽ߲ߔԍ*bufŎwnb_data󂯎܂B
  *
  * nb_dataҰU16߲ƂēnA]Ă߲ɂĎwꂽް
  * ͎󂯎ŏIIް ޲ĐōXV܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  *
  * @return	
  */
U8 host_get_data (U8 pipe, U16 *nb_data, U8 *buf)
{
	U8 status=PIPE_GOOD;
	U8 sav_int_sof_enable;
	U8 nak_timeout;
	U16 n,i;
	U16 cpt_nak;

	n=*nb_data;
	*nb_data=0;
	sav_int_sof_enable=Is_host_sof_interrupt_enabled();
	Host_enable_sof_interrupt();
	Host_select_pipe(pipe);
	Host_continuous_in_mode();
	Host_set_token_in();
	Host_ack_in_received();
	while (n)								// ް蓦Ă
	{
		Host_unfreeze_pipe();
		Host_send_in();
		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		nak_timeout=0;
		cpt_nak=0;
		while (!Is_host_in_received())
		{
			if (Is_host_emergency_exit())	// 荞݉Ōoꂽ񓯊ؒf܂͖ύX
			{
				status=PIPE_DELAY_TIMEOUT;
				Host_reset_pipe(pipe);
				goto host_get_data_end;
			}
	#if (TIMEOUT_DELAY_ENABLE==ENABLE)
			if (private_sof_counter>=250)	// ԒߊǗ
			{
				private_sof_counter=0;		// νSOF荞݂ōs܂B
				if (nak_timeout++>=TIMEOUT_DELAY)	// ǏԒߌ
				{
					status=PIPE_DELAY_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_get_data_end;
				}
			}
	#endif
			if(Is_host_pipe_error())		// ُǗ
			{
				status = Host_error_status();
				Host_ack_all_errors();
				goto host_get_data_end;
			}
			if(Is_host_stall())				// s\(STALL)Ǘ
			{
				status =PIPE_STALL;
				Host_reset_pipe(pipe);
				Host_ack_stall();
				goto host_get_data_end;
			}
	#if (NAK_TIMEOUT_ENABLE==ENABLE)
			if(Is_host_nak_received())		// NAKM
			{
				Host_ack_nak_received();
				if (cpt_nak++>NAK_RECEIVE_TIMEOUT)
				{
					status = PIPE_NAK_TIMEOUT;
					Host_reset_pipe(pipe);
					goto host_get_data_end;
				}
			}
	#endif
		}
		status=PIPE_GOOD;
		Host_freeze_pipe();
		if (Host_byte_counter()<=n)
		{
			if ((Host_byte_counter() < n)&&(Host_byte_counter()<Host_get_pipe_length()))
			{ n=0;}
			else
			{ n-=Host_byte_counter();}
			(*nb_data)+=Host_byte_counter();	// M޲ĐXV
			for (i=Host_byte_counter();i;i--)
			{ *buf=Host_read_byte(); buf++;}
		}
		else // \zM޲
		{	// ׂ:ُ필Ǘ
			*nb_data+=n;
			for (i=n;i;i--)				// vɐ޲Đ(limit tab over pb)
			{ *buf=Host_read_byte(); buf++; }
			n=0;
		}
		Host_ack_in_received();
	}
	Host_freeze_pipe();
host_get_data_end:
	if (sav_int_sof_enable==FALSE)
	{
		Host_disable_sof_interrupt();
	}
	return ((U8)status);
}

//___ 荞݊Ǘꂽް̗p֐ _________________________

#if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)

void reset_it_pipe_str (void)
{
	U8 i;
	for(i=0;i<MAX_EP_NB;i++)
	{
		it_pipe_str[i].enable=DISABLE;
		it_pipe_str[i].timeout=0;
	}
}

U8 is_any_interrupt_pipe_active (void)
{
	U8 i;
	for(i=0;i<MAX_EP_NB;i++)
	{
		if(it_pipe_str[i].enable==ENABLE) return TRUE;
	}
	return FALSE;
}

/**
  * @brief ̊֐͎w肵߲ߔԍ*bufŎwnb_data󂯎܂B
  *
  * nb_dataҰU16߲ƂēnA]Ă߲ɂĎwް
  * ͎󂯎ŏIIް ޲ĐōXV܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  * @param	handle	Ăі߂֐߲
  *
  * @return	
  */
U8 host_get_data_interrupt (U8 pipe, U16 nb_data, U8 *buf,void(*handle)(U8 status, U16 nb_byte))
{
	Host_select_pipe(pipe);
	if(it_pipe_str[pipe].enable==ENABLE)
	{
		return HOST_FALSE;
	}
	else
	{
		if(is_any_interrupt_pipe_active()==FALSE)
		{
			g_sav_int_sof_enable=Is_host_sof_interrupt_enabled();
			Host_enable_sof_interrupt();
		}
		it_pipe_str[pipe].enable=ENABLE;
		it_pipe_str[pipe].nb_byte_to_process=nb_data;
		it_pipe_str[pipe].nb_byte_processed=0;
		it_pipe_str[pipe].ptr_buf=buf;
		it_pipe_str[pipe].handle=handle;
		it_pipe_str[pipe].timeout=0;
		it_pipe_str[pipe].nak_timeout=NAK_RECEIVE_TIMEOUT;

		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		Host_reset_pipe(pipe);
		Host_enable_stall_interrupt();
	#if (NAK_TIMEOUT_ENABLE==ENABLE)
		Host_enable_nak_interrupt();
	#endif
		Host_enable_error_interrupt();
		Host_enable_receive_interrupt();
		Host_ack_stall();
		Host_ack_nak_received();

		Host_continuous_in_mode();
		Host_set_token_in();
		Host_unfreeze_pipe();
		return HOST_TRUE;
	}
}

/**
  * @brief ̊֐͎w肵߲ߔԍ*bufŎwnb_data𑗂܂B
  *
  * @param	pipe
  * @param	nb_data
  * @param	buf
  * @param	handle	Ăі߂֐߲
  *
  * @return	
  */
U8 host_send_data_interrupt (U8 pipe, U16 nb_data, U8 *buf, void(*handle)(U8 status, U16 nb_byte))
{
	U8 i;
	U8 *ptr_buf=buf;

	Host_select_pipe(pipe);
	if(it_pipe_str[pipe].enable==ENABLE)
	{
		return HOST_FALSE;
	}
	else
	{
		if(is_any_interrupt_pipe_active()==FALSE)
		{
			g_sav_int_sof_enable=Is_host_sof_interrupt_enabled();
			Host_enable_sof_interrupt();
		}
		it_pipe_str[pipe].enable=ENABLE;
		it_pipe_str[pipe].nb_byte_to_process=nb_data;
		it_pipe_str[pipe].nb_byte_processed=0;
		it_pipe_str[pipe].ptr_buf=buf;
		it_pipe_str[pipe].handle=handle;
		it_pipe_str[pipe].timeout=0;
		it_pipe_str[pipe].nak_timeout=NAK_SEND_TIMEOUT;
		it_pipe_str[pipe].nb_byte_on_going=0;

		Host_reset_pipe(pipe);
		Host_unfreeze_pipe();
		// ׂް
		i = Host_get_pipe_length();
		if ( i > nb_data)					// ߲ߗe>cް
		{
			i = nb_data;
			nb_data = 0;
		}
		else								// ߲ߗeʁcް
		{
			nb_data -= i;
		}
		it_pipe_str[pipe].nb_byte_on_going+=i;	// ްXV
		while (i!=0)						// ߲ߊɏՕݒ
		{	Host_write_byte(*ptr_buf++); i--;
		}
		private_sof_counter=0;				// SOFoٰݓ̌vؾ
		it_pipe_str[pipe].timeout=0;		// ԌoߌvĊ
		Host_ack_out_sent();
		Host_ack_stall();
		Host_ack_nak_received();

		Host_enable_stall_interrupt();
		Host_enable_error_interrupt();
	#if (NAK_TIMEOUT_ENABLE==ENABLE)
		Host_enable_nak_interrupt();
	#endif
		Host_enable_transmit_interrupt();
		Host_send_out();					// USBڰёo
		return HOST_TRUE;
	}
}

//! @brief USB߲ߊ荞ݻٰ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#ifdef AVRGCC
ISR(USB_COM_vect)
#else
#pragma vector = USB_ENDPOINT_PIPE_vect
__interrupt void usb_pipe_interrupt()
#endif
{
	U8 pipe_nb;
	U8 *ptr_buf;
	void (*fct_handle)(U8 status,U16 nb_byte);
	U16 n;
	U8 i;
	U8 do_call_back=FALSE;

	pipe_nb_save = Host_get_selected_pipe();	// dv! ߲ߔԍŕۑ
	pipe_nb=usb_get_nb_pipe_interrupt();	// 荞݂𐶐鐳߲ߔԍœB
	Host_select_pipe(pipe_nb);				// ߲߂I
	fct_handle=*(it_pipe_str[pipe_nb].handle);

	// ǂ̎ۂ荞݂𐶐o݂B

	if (Is_host_pipe_error())				// ُ?
	{
		it_pipe_str[pipe_nb].status = Host_error_status();
		it_pipe_str[pipe_nb].enable=DISABLE;
		Host_stop_pipe_interrupt(pipe_nb);
		Host_ack_all_errors();
		do_call_back=TRUE;
		goto usb_pipe_interrupt_end;
	}

	if (Is_host_stall())					// s\(STALL)޼M?
	{
		it_pipe_str[pipe_nb].status=PIPE_STALL;
		it_pipe_str[pipe_nb].enable=DISABLE;
		Host_stop_pipe_interrupt(pipe_nb);
		do_call_back=TRUE;
		goto usb_pipe_interrupt_end;
	}

	#if (NAK_TIMEOUT_ENABLE==ENABLE)
	if (Is_host_nak_received())				// NAK?
	{
		Host_ack_nak_received();
		// NAKԒ߈ُ픭̔ԍ(荞݌`߲߂ɑ΂Ăł͂Ȃ)
		if((--it_pipe_str[pipe_nb].nak_timeout==0) && (Host_get_pipe_type()!=TYPE_INTERRUPT))
		{
			it_pipe_str[pipe_nb].status=PIPE_NAK_TIMEOUT;
			it_pipe_str[pipe_nb].enable=DISABLE;
			Host_stop_pipe_interrupt(pipe_nb);
			do_call_back=TRUE;
			goto usb_pipe_interrupt_end;
		}
		}
	#endif

	if (Is_host_in_received())				// ߲INM?
	{
		ptr_buf=it_pipe_str[pipe_nb].ptr_buf+it_pipe_str[pipe_nb].nb_byte_processed;	// ްɏՕւ߲\z
		n=it_pipe_str[pipe_nb].nb_byte_to_process-it_pipe_str[pipe_nb].nb_byte_processed;	// cް ޲
		Host_freeze_pipe();
		if (Host_byte_counter()<=n)
		{
			if ((Host_byte_counter() < n)&&(Host_byte_counter()<Host_get_pipe_length()))	// c薢MA߲ߗeʖ
											// ׂ:ُ필
			{
				n=0;
			}
			else
			{
				n-=Host_byte_counter();
			}
			it_pipe_str[pipe_nb].nb_byte_processed+=Host_byte_counter();	// M޲ĐXV
			for (i=Host_byte_counter();i;i--)
			{ *ptr_buf=Host_read_byte(); ptr_buf++;}
		}
		else  // \M޲
		{     // ׂ:ُ필Ǘ
			it_pipe_str[pipe_nb].nb_byte_processed+=n;
			for (i=n;i;i--)					// vɐ޲Đ(limit tab over pb)
			{ *ptr_buf=Host_read_byte(); ptr_buf++;}
			n=0;
		}
		Host_ack_in_received();
		if(n>0)								// ̂߂̉
		{
			Host_unfreeze_pipe();			// ʂIN]v
			Host_send_in();
			private_sof_counter=0;			// SOFoٰݓ̌vؾ
			it_pipe_str[pipe_nb].timeout=0;	// oߎؾ
			it_pipe_str[pipe_nb].nak_timeout=NAK_RECEIVE_TIMEOUT;

		}
		else								// ]I
		{
			it_pipe_str[pipe_nb].enable=DISABLE;
			it_pipe_str[pipe_nb].status=PIPE_GOOD;
			Host_stop_pipe_interrupt(pipe_nb);
			do_call_back=TRUE;
		}
	}

	if(Is_host_out_sent())					// ߲OUTo?
	{
		Host_ack_out_sent();
		it_pipe_str[pipe_nb].nb_byte_processed+=it_pipe_str[pipe_nb].nb_byte_on_going;
		it_pipe_str[pipe_nb].nb_byte_on_going=0;
		ptr_buf=it_pipe_str[pipe_nb].ptr_buf+it_pipe_str[pipe_nb].nb_byte_processed;	//  ްɏՕւ߲\z
		n=it_pipe_str[pipe_nb].nb_byte_to_process-it_pipe_str[pipe_nb].nb_byte_processed;	// cް ޲
		if(n>0)								// ̂߂ް
		{
			Host_unfreeze_pipe();
			// ׂް
			i = Host_get_pipe_length();
			if ( i > n)						// ߲ߗe>cް
			{
				i = n;
				n = 0;
			}
			else							// ߲ߗeʁcް
			{ n -= i; }
			it_pipe_str[pipe_nb].nb_byte_on_going+=i;	// ꂽްXV
			while (i!=0)					// ߲ߊɏՕݒ
			{
				Host_write_byte(*ptr_buf++); i--;
			}
			private_sof_counter=0;			// SOFoٰݓ̌vؾ
			it_pipe_str[pipe_nb].timeout=0;	// ԒߌvĊ
			it_pipe_str[pipe_nb].nak_timeout=NAK_SEND_TIMEOUT;
			Host_send_out();				// USBڰёo
		}
		else								// n==0A]I
		{
			it_pipe_str[pipe_nb].enable=DISABLE;	// ]I
			it_pipe_str[pipe_nb].status=PIPE_GOOD;	// OK
			Host_stop_pipe_interrupt(pipe_nb);
			do_call_back=TRUE;
		}
	}

usb_pipe_interrupt_end:
	Host_select_pipe(pipe_nb_save);			// ߲ߔԍ!!!!
	if (is_any_interrupt_pipe_active()==FALSE)	// ȏ]ꍇ
	{
		if (g_sav_int_sof_enable==FALSE)
		{
			Host_disable_sof_interrupt();
		}
	}
	if(do_call_back)						// s邽߂̉ꂩ̌Ăі߂֐?
	{
		fct_handle(it_pipe_str[pipe_nb].status,it_pipe_str[pipe_nb].nb_byte_processed);
	}
}
#endif

#endif // USB_HOST_FEATURE ENABLE
